{% extends 'proj/base.html' %}

{% block content %}
{% load static %}
<div class="smallpage">
    <h2>Formule manuelle</h2>

    <p>La syntaxe des formules repose sur celle de la libraire <a href="https://pandas.pydata.org/">pandas</a> de
        Python. Les variables disponibles sont {{ vars|safe }}. Chaque variable représente les valeurs journalières des modèles climatiques.
        Ces valeurs sont alignées
        sur 360 jours par an. Vous pouvez <a href="{% url 'proj:download'%}#params">télécharger les données brutes</a> de ces variables.
    </p>

    <h3>Quelques exemples de formules</h3>
    <dl class="description">
        <dt style="color:blue">pr</dt>
        <dd>Sélectionne toutes les précipitations (y compris nulles). En conjonction avec "somme", produit le cumul des précipitations.
            Avec "max", la précipitation maximale (en mm/jour), et ainsi de suite. Utiliser "compter" renverra la valeur constante 360.</dd>

        <dt style="color:blue">tas</dt>
        <dd>Sélectionne toutes les températures moyennes. On peut constater par exemple que le maximum des
            températures moyennes (<kbd>tas</kbd> avec "max") est différent de la moyenne des températures maximales
            (<kbd>tasmax</kbd> avec "moyenne").</dd>

        <dt style="color:blue">pr[pr>=3]</dt>
        <dd>Sélectionne les précipitations supérieures ou égales à 3mm. En conjonction avec "compter", renvoie le nombre
            de jours de pluie selon ce critère.</dd>

        <dt style="color:blue">tas[pr<3]</dt>
        <dd>On peut mélanger plusieurs variables. Ici, on a sélectionné les températures des jours sans pluie, dont on
            peut par exemple extraire la moyenne.</dd>

        <dt style="color:blue">tasmax-tasmin</dt>
        <dd>Amplitude de température journalière. À utilser en conjonction avec "max" (amplitude maximale) ou "moyenne"
            (amplitude moyenne), par exemple.</dd>
    </dl>
    <h3>Valeurs globales</h3>
    <p>Certaines valeurs globales peuvent être calculées pour chaque variable, sous la forme <kbd>x.methode()</kbd>,
        où <kbd>x</kbd> est la variable. Les méthodes disponibles sont les suivantes.</p>
    <table style="border:1px solid gray">
        <thead style="background-color:#cccccc;font-style:italic"><td>fonction</td><td>description</td><td>note</td></thead>
        <tr><td><kbd>max</kbd></td><td>maximum</td></tr>
        <tr><td><kbd>min</kbd></td><td>minimum</td></tr>
        <tr><td><kbd>mean</kbd></td><td>moyenne</td></tr>
        <tr><td><kbd>std</kbd></td><td>écart-type</td></tr>
        <tr><td><kbd>median</kbd></td><td>médiane</td></tr>
        <tr><td><kbd>quantile</kbd></td><td>percentile</td><td>prend un argument entre 0 et 1</td></tr>
    </table>
    <p>Par exemple :</p>
    <dl class="description">
        <dt style="color:blue">pr[pr > pr.mean()]</dt>
        <dd>Sélectionne les précipitations supérieures à la moyenne.</dd>
        <dt style="color:blue">tasmax[tasmax > tasmax.quantile(.95)]</dt>
        <dd>Sélectionne les températures max supérieures aux 95e percentile.</dd>
    </dl>
    <p>En plus de ces méthodes, la fonction <kbd>abs()</kbd> calcule la valeur absolue.</p>
    <dl class="description">
        <dt style="color:blue">abs(tas-tas.mean())</dt>
        <dd>Avec "moyenne", calcule l'écart moyen à la moyenne (différent de l'écart-type).</dd>
    </dl>
    <h3>Jours consécutifs</h3>
    <p>La fonction <kbd>consec</kbd> calcule le nombre de jours consécutifs pour une certaine propriété.</p>
    <dl class="description">
        <dt style="color:blue">consec(tasmax>35)</dt>
        <dd>Nombre de jours consécutifs où la température dépasse 35°C.
            À utiliser en conjonction avec "max" pour les métriques du type "plus longue suite de jours où ..." </dd>
        <dt style="color:blue">consec(tasmax>35) >= 6</dt>
        <dd>Identifie les intervalles <i>avec chevauchement</i> de températures supérieure à 35°C pendant au moins 6 jours
            (à utiliser en conjonction avec "somme" pour les compter, voir plus bas pour une explication complète).</dd>
    </dl>
    <p>Si l'on veut éviter les chevauchements d'intervalles, il faut utiliser la fonction <kbd>consec2</kbd>. Celle-ci
        prend un argument supplémentaire, le nombre de jours de chaque intervalle.</p>
    <dl class="description">
        <dt style="color:blue">consec2(tasmax>35, 6)</dt>
        <dd>En conjonction avec "somme", compte le nombre d'intervalles de 6 jours, <i>sans chevauchement,</i> où la
            température dépasse 35°C. S'il y a un intervalle de 10 jours consécutifs, la fonction le compte comme un seul (de 6 jours).
            Pour 12 jours consécutifs, la fonction compte bien 2 intervalles (de 6 jours).</dd>
    </dl>
    <h3>Utilisation avancée</h3>
    <p>Une formule logique, dont l'opérateur principal est une comparaison
        (<kbd>></kbd>, <kbd><</kbd>, <kbd>>=</kbd>, <kbd><=</kbd>, <kbd>==</kbd>)
        ou bien une sortie de la fonction <kbd>consec2()</kbd>, renvoie un tableau
        de booléens, c'est-à-dire de valeurs vrai/faux. On s'en sert généralement pour indexer un autre tableau.
        Par exemple, <kbd>pr</kbd> est un tableau de valeurs de précipitations,
    <kbd>pr>=3</kbd> un tableau de booléens (vrai si la précipitation est supérieure ou égale à 3mm),
    <kbd>pr[pr>=3]</kbd> est le tableau de valeurs de précipitation dans lequel on n'a retenu que les indices <i>vrai</i>
        du tableau précédent.</p>

    <p><b>Attention :</b> les booléens sont assimilables à des entiers (1 pour vrai, 0 pour faux).
        Il est donc possible de compter
        directement les valeurs <i>vrai</i> en réalisant leur somme. Par exemple, <kbd>pr[pr>=3]</kbd> + "compter", qui compte
        le nombre de jours de pluie, est
        équivalent à la formule plus courte <kbd>pr>=3</kbd> + "somme". Par contre, <kbd>pr>=3</kbd> + "compter" renverra simplement
        le nombre de jours dans l'année, soit 360.</p>

</div>


{% endblock %}